<script setup lang="ts">
import { computed, nextTick, onMounted, ref } from 'vue'

import type { Stock } from '@/types/Stock'
import type { VForm } from 'vuetify/components'
import { useStockStore } from '@/stores/stock'

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'QTY',
    key: 'qty',
    value: 'qty'
  },
  {
    title: 'Price(Unit)',
    key: 'priceUnit',
    value: (item: Stock) => item.priceUnit.toFixed(2)
  },
  {
    title: 'Value',
    key: 'value',
    value: (item: Stock) => item.value.toFixed(2)
  },
  { title: '', key: 'actions', sortable: false }
]

const stockStore = useStockStore()
const search = ref('')
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const updateDialog = ref(false)
const printDialog = ref(false)

const filteredStock = computed(() => {
  return stockStore.stocks.filter((stocks) =>
    stocks.name.toUpperCase().includes(search.value.toUpperCase())
  )
})

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await stockStore.saveStock()
  closeDialog()
}

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    stockStore.clearForm()
  })
}

async function deleteItemConfirm() {
  await stockStore.deleteStock()
  closeDelete()
}

async function deleteItem(item: Stock) {
  if (!item.id) return
  await stockStore.getStock(item.id)
  dialogDelete.value = true
}

async function editItem(item: Stock) {
  if (!item.id) return
  await stockStore.getStock(item.id)
  dialog.value = true
}

function closeDialog() {
  dialog.value = false
  updateDialog.value = false
  printDialog.value = false
  nextTick(() => {
    stockStore.clearForm()
  })
}

function getColor(qty: number) {
  if (qty < 1) {
    return 'red'
  } else if (qty <= 10) {
    return 'orange'
  } else {
    return 'green'
  }
}

onMounted(async () => {
  await stockStore.getStocks()
})
</script>

<template>
  <div style="width: 95%; height: 100%">
    <v-card-title class="d-flex align-center pe-2">
      <v-spacer></v-spacer>
    </v-card-title>
    <v-data-table :headers="headers" :items="filteredStock">
      <template v-slot:[`item.qty`]="{ value }">
        <v-chip :color="getColor(value)">
          {{ value }}
        </v-chip>
      </template>

      <template v-slot:top>
        <v-toolbar flat color="#F48FB1">
          <v-toolbar-title> <v-icon icon="mdi-package"> </v-icon>Stock</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn class="mx-2" color="#ECEFF1" variant="flat" v-bind="props">
                <v-icon icon="mdi-plus"> </v-icon>
                New Stock
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Stock Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="stockStore.editedStock.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          type="number"
                          v-model="stockStore.editedStock.qty"
                          :readonly="loading"
                          :rules="[(v) => v >= 0]"
                          class="mb-2"
                          clearable
                          label="QTY"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          type="number"
                          v-model.number="stockStore.editedStock.priceUnit"
                          :readonly="loading"
                          :rules="[(v) => v >= 0]"
                          class="mb-2"
                          clearable
                          label="PricePerUnit"
                          placeholder="Enter your PricePerUnit"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" @click="closeDialog"> Close </v-btn>
                <v-btn color="green" variant="flat" @click="save"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" @click="closeDelete">Cancel</v-btn>
                <v-btn color="green" variant="flat" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- dialog for update qty -->
          <!-- <v-dialog v-model="updateDialog" persistent width="400" height="650">

                        <template v-slot:activator="{ props }">
                            <v-btn class="mx-2" color="#ECEFF1" variant="flat" v-bind="props">
                                <v-icon icon="mdi-update">
                                </v-icon>
                                Update Quantity
                            </v-btn>
                        </template>
                        <v-card>
                            <v-card-title>
                                <span class="text-h5">Quantity</span>
                            </v-card-title>
                            <v-table>
                                <thead>
                                    <tr>
                                        <th class="text-left">Name</th>
                                        <th class="text-left">Quantity</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-for="item in stockStore.stocks" :key="item.name">
                                        <td>{{ item.name }}</td>
                                        <td>
                                            <v-responsive max-width="100">
                                                <v-text-field v-model="item.qty"></v-text-field>
                                            </v-responsive>
                                        </td>
                                    </tr>
                                </tbody>
                            </v-table>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="red" variant="flat" @click="closeDialog">
                                    Close
                                </v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog> -->
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-text-field
            class="mx-2"
            v-model="search"
            prepend-inner-icon="mdi-magnify"
            density="compact"
            label="Search"
            single-line
            flat
            hide-details
            variant="outlined"
          ></v-text-field>
        </v-toolbar>
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)">mdi-pencil</v-icon>
        <v-icon size="small" @click="deleteItem(item)">mdi-delete</v-icon>
      </template>
    </v-data-table>
    <!-- printDialog -->
    <div>
      <v-dialog v-model="printDialog" persistent width="1024">
        <template v-slot:activator="{ props }">
          <v-btn class="mx-2 my-2" color="#F48FB1" v-bind="props"> Print </v-btn>
        </template>
        <v-card>
          <v-card-title> Check Stock </v-card-title>
          <v-table>
            <thead>
              <tr>
                <th class="text-left">Name</th>
                <th class="text-left">Quantity</th>
                <th class="text-left">Remain</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="item in stockStore.stocks" :key="item.id">
                <td>{{ item.name }}</td>
                <td>{{ item.qty }}</td>
                <td></td>
              </tr>
            </tbody>
          </v-table>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="red" variant="flat" @click="closeDialog"> Close </v-btn>
            <v-btn color="green" variant="flat"> Print </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </div>
  </div>
</template>
